//+------------------------------------------------------------------+
//|                                               Stochastic RSI.mq4 |
//|                                                 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "No body it is free"
#property link      ""

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_minimum    -5
#property indicator_maximum    105
#property indicator_color1     Red
#property indicator_color2     LimeGreen
#property indicator_color3     Red
#property indicator_color4     Yellow
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_levelcolor Peru

//
//
//
//
//

extern int    RSI_Periods           = 14;
extern int    Percent_K             = 14;
extern int    Percent_D             = 9;
extern double levelOb               = 80;
extern double levelOs               = 20;
extern bool   alertsOn              = true;
extern bool   alertsOnCurrent       = true;
extern bool   alertsOnStochRsiCross = true;
extern bool   alertsOnSignalCross   = true;
extern bool   alertsMessage         = true;
extern bool   alertsSound           = true;
extern bool   alertsNotify          = false;
extern bool   alertsEmail           = false;
extern string soundFile             = "alert2.wav";

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Upa[];
double Dna[];
double trend[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,Dna);     SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,167);
   SetIndexBuffer(1,Upa);     SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,167);
   SetIndexBuffer(2,Buffer1); SetIndexLabel(2,"StochRSI");
   SetIndexBuffer(3,Buffer2); SetIndexLabel(3,"Signal");
   SetIndexBuffer(4,trend);
   SetIndexBuffer(5,trend1);
   SetIndexBuffer(6,trend2);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   return(0);
}

int deinit()  { return(0); }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(int i=limit;i>=0;i--)
   { 
      double Current_RSI=iRSI(NULL,0,RSI_Periods,PRICE_TYPICAL,i);
      double Highest_RSI=Current_RSI;
      double Lowest_RSI=Current_RSI;
      for(int x=0;x<=Percent_K;x++){
            Lowest_RSI =MathMin(Lowest_RSI ,iRSI(NULL,0,RSI_Periods,PRICE_TYPICAL,i+x));
            Highest_RSI=MathMax(Highest_RSI,iRSI(NULL,0,RSI_Periods,PRICE_TYPICAL,i+x));
         }

      double sum_K=0;
      if ((Highest_RSI-Lowest_RSI)!=0)
            Buffer1[i]=((Current_RSI-Lowest_RSI)/(Highest_RSI-Lowest_RSI))*100;
      else  Buffer1[i]=0;
      for(x=0;x<=Percent_D;x++) sum_K+=Buffer1[i+x];
         Buffer2[i]=sum_K/Percent_D;
         
         Dna[i]   = EMPTY_VALUE;
         Upa[i]   = EMPTY_VALUE;
         trend[i] = trend[i+1];
         if (Buffer1[i]>50 && Buffer1[i]>Buffer2[i]) trend[i] =  1;
         if (Buffer1[i]<50 && Buffer1[i]<Buffer2[i]) trend[i] = -1;
         if (trend[i]== 1) Upa[i] = 50;
         if (trend[i]==-1) Dna[i] = 50;
         
         //
         //
         //
         //
         //
         
         trend1[i] = 0;
         trend2[i] = 0;
           if (Buffer1[i]>levelOb) trend1[i] = 1;
           if (Buffer1[i]<levelOs) trend1[i] =-1; 
           if (Buffer2[i]>levelOb) trend2[i] = 1;
           if (Buffer2[i]<levelOs) trend2[i] =-1; 
  
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
    
        //
        //
        //
        //
        //
      
        static datetime time1 = 0;
        static string   mess1 = "";
           if (alertsOnStochRsiCross && trend1[whichBar] != trend1[whichBar+1])
           {
              if (trend1[whichBar+1] == 1 && trend1[whichBar] != 1) doAlert(time1,mess1,whichBar," crossing overbought down");
              if (trend1[whichBar+1] ==-1 && trend1[whichBar] !=-1) doAlert(time1,mess1,whichBar," crossing oversold up");
           }            
        static datetime time2 = 0;
        static string   mess2 = "";
           if (alertsOnSignalCross && trend2[whichBar] != trend2[whichBar+1])
           {
              if (trend2[whichBar+1] == 1 && trend2[whichBar] != 1) doAlert(time2,mess2,whichBar," Signal crossing overbought down");
              if (trend2[whichBar+1] ==-1 && trend2[whichBar] !=-1) doAlert(time2,mess2,whichBar," Signal crossing oversold up");
           }                        
} 
return(0);
}  

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," StochRSI ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," StochRSI "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," StochRSI " +" "+message));
             if (alertsSound)   PlaySound(soundFile);
      }
}
       


